var heap_swaps = 0;
var heap_siftDowns = 0;

function heapsort(array) {
	return heapsort_rec(array, array.length);
}

function heapsort_rec(array, length) {
	heapify(array, length); // place array in max-heap order
	
	var end = length-1; // the children are 2*i+1 and 2*i+2
	while (end > 0) {
		heap_swaps++;
		swap(array, end, 0);    // swap root(max value) of heap with the last element of heap
		end--;                   // decrease size of heap by one -> previous max value will stay in proper placement
		siftDown(array, 0, end); // put heap back in max-heap order
	}
	return array;
}

function heapify(array, length) {
	var start = (length - 2) / 2;         // start is assigned the index in array of the last parent node
	while (start >= 0) {
		siftDown(array, start, length-1); // sift down the node at index start to the proper place such that all nodes below start are in heap order
		start = start - 1;                // after sifting down the root all nodes/elements are in heap order
	}
}

function siftDown(array, start, end) {
	heap_siftDowns++;
	var root = start;
	while (root * 2 + 1 <= end) {       // While root has at least one child
		var child = root * 2 + 1;       // root*2 + 1 => left child
		var swapIdx = root;                // keeps track of child to swap with
		if (array[swapIdx] < array[child]) // check if root is smaller than left child
			swapIdx = child;
		if (child+1 <= end && array[swapIdx] < array[child+1]) // check if right child exists, and if it's bigger than what we're currently swapping with
			swapIdx = child + 1;
		if (swapIdx != root) {             // check if need to swap at all
			heap_swaps++;
			swap(array, root, swapIdx);
			root = swapIdx;                // repeat to continue sifting down the child
		}
		else {
			return;
		}
	}
}

//alert("heap: " + heapsort([1,6,3,2,0,4,7,2]));