/**
 * @author jtan
 */

/**
 * Dumps all data contained in an arbitrary object into an alert together with an optional message.
 * 
 * @param obj - {Object}
 * @param msg - {String}
 */
function dump(obj, msg) {
    var out = '';
    for (var i in obj) {
        out += i + ": " + obj[i] + "\n";
    }
    alert((msg?msg:"") + out);
}


function isNumber (o) {
	return ! isNaN (o-0) && o !== null && o.replace(/^\s\s*/, '') !== "" && o !== false;
}

function swap(array, index1, index2) {
	var tmp = array[index1];
	array[index1] = array[index2];
	array[index2] = tmp;
}

function endsWith(str, suffix) {
    return str.indexOf(suffix, str.length - suffix.length) !== -1;
}

function isSorted(array) {
	if(array.length < 2) return true;
	
	var flag = false;
	var ascending = true;
	var descending = true;
	var lastVal = array[0];
	for(var i=1; i<array.length; i++) {
		if(!flag) {
			if(lastVal < array[i]) { descending = false; flag = true; }
			if(lastVal > array[i]) { ascending  = false; flag = true;  }
		}
		else {
			if(descending && lastVal < array[i]) {
				descending = false;
//				alert("desc-index: " + i + "  last: " + lastVal + "  val: " + array[i]);
				break;
			}
			if(ascending && lastVal > array[i]) {
				ascending = false;
//				alert("asc-index: " + i + "  last: " + lastVal + "  val: " + array[i]);
				break;
			}
		}
		lastVal = array[i];
	}
	
	return ascending ? "asc" : descending ? "desc" : "unsorted";
}
